-- The enhanced infamous `Hello World!' program using the GTK binding for
-- Haskell 
--
--    ghc -o hello2 -fglasgow-exts -i.. -L.. -lgtkHS GtkHelloWorld2.hs\
--      `gtk-config --cflags` `gtk-config --libs`
--

import System (getArgs, ExitCode(ExitSuccess))
import Gtk    (GtkWindowType(..),
	       GtkButton, gtkButtonNewWithLabel,
	       GtkButtonSignalHandler(..), gtkButtonSignalConnect,
	       GtkContainer, gtkContainerSetBorderWidth, gtkContainerAdd,
	       GtkWidget, gtkWidgetShow,
	       GtkWindow, gtkWindowNew,
	       gtkInit, gtkMain, gtkExit)

hello :: IO ()
hello  = do
	   putStr "Hello World!\n"
	   gtkExit ExitSuccess

main :: IO ()
main  = do
          preArgs <- getArgs
	  _ <- gtkInit preArgs

	  window <- gtkWindowNew GtkWindowToplevel
	  gtkContainerSetBorderWidth window 10

	  button <- gtkButtonNewWithLabel "Hello World!"
	  gtkButtonSignalConnect button (GtkButtonClickedHandler (const hello))
	  gtkContainerAdd window button
	  gtkWidgetShow button

	  gtkWidgetShow window

	  gtkMain
